/*jslint nomen: true, indent: 2, maxerr: 3, maxlen: 80*/
/*global window, RSVP, rJS, jIO*/
(function (window, RSVP, rJS, jIO) {
 "use strict";
 rJS(window)
 
 .ready(function(){
  this.search_storage = jIO.createJIO({
    type : "query",
      sub_storage:{
        type : "uuid",
        sub_storage : {
          type: "indexeddb", 
          database: "mynij-v1"
        }
      }
  });
  this.info = jIO.createJIO({
    type : "indexeddb",
    database : "mynij-v1-info"
  });
 })
 
 .declareMethod("put", function () {
    return this.search_storage.post.apply(this.search_storage, arguments);
 })
 
 .declareMethod("get", function () {
    return this.search_storage.get.apply(this.search_storage, arguments);
 })
 
 .declareMethod("search", function() {
    return this.search_storage.allDocs.apply(this.search_storage, arguments)
 })
 
 .declareMethod("loaded_doc", function(){
   return this.info.put.apply(this.info, arguments);
 })
 
 .declareMethod("all_loaded_docs", function(){
   return this.info.allDocs.apply(this.info, arguments);
 });
}(window, RSVP, rJS, jIO));