/*jslint nomen: true, indent: 2, maxerr: 3, maxlen: 80*/
/*global window, RSVP, rJS, jIO*/
(function(window, RSVP, rJS, jIO) {
  "use strict";
    rJS(window)
    
    .declareAcquiredMethod("get_model", "get_model")

    .declareMethod("readFile", function(link) {
      var storage;
      var gadget = this;
      gadget.get_model()
      .push(function(result) {
        storage = result;
      })
      .push(function() {
        var xmlhttp = new XMLHttpRequest();
        xmlhttp.onreadystatechange = function() {
          if (xmlhttp.status == 200 && xmlhttp.readyState == 4) {
            var cur_text = xmlhttp.responseText,
                promise_list = [],
                feed_title;
            feed_title = cur_text.slice(cur_text.indexOf("<title>")+7, cur_text.indexOf("</title>"));
            gadget.is_already_parsed(storage, feed_title)
            .push (function (resultat){
              if (!resultat){
                promise_list.push(storage.loaded_doc(feed_title, {"loaded" : "true"}));
                cur_text = cur_text.slice(cur_text.indexOf("<item>"), cur_text.length - 1);
                while (cur_text.indexOf("<item>") > -1) {
                  promise_list.push(gadget.parse(cur_text, storage));
                  cur_text = cur_text.slice(cur_text.indexOf("</item>") + 6, cur_text.length - 1);
                }
                RSVP.all(promise_list);
              }
            });
          }
        };
        xmlhttp.open("GET", link, true);
        xmlhttp.send();
      });
    })
    
    .declareMethod("parse", function(local_cur_text, storage) {
      var title_start = local_cur_text.indexOf("<title>") + 7,
          title_end = local_cur_text.indexOf("</title>"),
          link_start = local_cur_text.indexOf("<link>") + 6,
          link_end = local_cur_text.indexOf("</link>"),
          body_start = local_cur_text.indexOf("<description>"),
          body_end = local_cur_text.indexOf("</description>") + 14;
      return this.parse_body(local_cur_text.slice(body_start, body_end))
        .push (function(result){
          return storage.put({
            "title": local_cur_text.slice(title_start, title_end),
            "link": local_cur_text.slice(link_start, link_end),
            "body": result
          });
        });
    })
    
    .declareMethod("parse_body", function(body){
      /*var before,
          after;
      while (body.indexOf("&lt;span style") > -1){
        before = body.slice(0, body.indexOf("&lt;span style"));
        after = body.slice(body.indexOf("&quot;&gt"), body.length -1);
        body = before + after;
      }
      console.log(body);*/
      return body;
    })
    
    .declareMethod("is_already_parsed", function(storage, title){
      return storage.all_loaded_docs()
      .push(function (result){
        var i;
        for (i = 0; i<result.data.rows.length; i+=1){
          //console.log(result.data.rows[i].id);
          if (result.data.rows[i].id === title) return true;
        }
        return false;
      })
    });
  
}(window, RSVP, rJS, jIO));