/*jslint nomen: true, indent: 2, maxerr: 3, maxlen: 80*/
/*global window, RSVP, rJS, jIO*/
(function(window, RSVP, rJS, jIO) {
    "use strict";
    rJS(window)

    .declareMethod("addItem", function(item, key) {
      var list,
          list_item,
          title,
          link,
          body,
          body_text,
          parser,
          xmlDoc;

      list = document.getElementById("list");
      list_item = document.createElement("LI");

      title = document.createElement("a");
      title.appendChild(document.createTextNode(item.title));
      title.className="title";
      title.href = item.link;
      list_item.appendChild(title);
      
      link = document.createElement("a");
      link.appendChild(document.createTextNode(item.link));
      link.href = item.link;
      link.className = "link";
      var link_par = document.createElement('p');
      link_par.appendChild(link);
      list_item.appendChild(link_par);
      
      body = document.createElement('p');
      body.className = "body";
      if (key === ""){
        body.innerHTML = "";
        list.appendChild(list_item);
      } else {
        parser = new DOMParser();
        xmlDoc = parser.parseFromString(item.body,"text/xml");
        body_text = xmlDoc.getElementsByTagName("description")[0].childNodes[0].nodeValue;
        console.log("ok : " + item.title);
        return this.cut_description(body_text, key)
        .push(function (result){
          //console.log(item.title);
          if (result === null) body.innerHTML = "";
          else body.innerHTML = result.slice(1);
          list_item.appendChild(body);
          list.appendChild(list_item);
        })
        
      }
    })
    
    .declareMethod("clear", function(){
      var list = document.getElementById("list");
      while (list.firstChild) {
        list.removeChild(list.firstChild);
      }
    })
    
    .declareMethod("cut_description", function(body, key){
      var regEx,
          result;
      regEx = new RegExp('[^.]*' +" " + key + " " + '[^.]*\.', 'g');
      result = regEx.exec(body);
      if (result === null) return null;
      else return result[0];
    });

}(window, RSVP, rJS, jIO));